#!/usr/bin/ruby
######################################################################
# Copyright (C) 2007, Ihar Hrachyshka <ihar.hrachyshka@gmail.com>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# System requirements:
# Ruby interpreter: tested for 1.8.x only (http://www.ruby-lang.org)
# Make sure you have "ruby" executable in your PATH environment!
# For Unix, make sure this file has "x" attribute enabled!
######################################################################
# Usage:
# $ ./cyr2lat [filename] # for Unix
# $ ruby ./cyr2lat [filename] # for others
# Program reads Belarusian cyrillic text from 'filename' file, or from
# stdin if 'filename' is not specified, and pipes latinized text to
# stdout. To save the results to a file, you should redirect it:
# $ ./cyr2lat [filename] > output_file
######################################################################
def cyr2lat(line)
	line.gsub!('Ба', 'Ba')
	line.gsub!('ба', 'ba')
	line.gsub!('Бе', 'Bie')
	line.gsub!('бе', 'bie')
	line.gsub!('Бё', 'Bio')
	line.gsub!('бё', 'bio')
	line.gsub!('Бі', 'Bi')
	line.gsub!('бі', 'bi')
	line.gsub!('Бо', 'Bo')
	line.gsub!('бо', 'bo')
	line.gsub!('Бу', 'Bu')
	line.gsub!('бу', 'bu')
	line.gsub!('Бы', 'By')
	line.gsub!('бы', 'by')
	line.gsub!('Бэ', 'Be')
	line.gsub!('бэ', 'be')
	line.gsub!('Бю', 'Biu')
	line.gsub!('бю', 'biu')
	line.gsub!('Бя', 'Bia')
	line.gsub!('бя', 'bia')

	line.gsub!('Ва', 'Va')
	line.gsub!('ва', 'va')
	line.gsub!('Ве', 'Vie')
	line.gsub!('ве', 'vie')
	line.gsub!('Вё', 'Vio')
	line.gsub!('вё', 'vio')
	line.gsub!('Ві', 'Vi')
	line.gsub!('ві', 'vi')
	line.gsub!('Во', 'Vo')
	line.gsub!('во', 'vo')
	line.gsub!('Ву', 'Vu')
	line.gsub!('ву', 'vu')
	line.gsub!('Вы', 'Vy')
	line.gsub!('вы', 'vy')
	line.gsub!('Вэ', 'Ve')
	line.gsub!('вэ', 've')
	line.gsub!('Вю', 'Viu')
	line.gsub!('вю', 'viu')
	line.gsub!('Вя', 'Via')
	line.gsub!('вя', 'via')

	line.gsub!('Га', 'Ha')
	line.gsub!('га', 'ha')
	line.gsub!('Ге', 'Hie')
	line.gsub!('ге', 'hie')
	line.gsub!('Гё', 'Hio')
	line.gsub!('гё', 'hio')
	line.gsub!('Гі', 'Hi')
	line.gsub!('гі', 'hi')
	line.gsub!('Го', 'Ho')
	line.gsub!('го', 'ho')
	line.gsub!('Гу', 'Hu')
	line.gsub!('гу', 'hu')
	line.gsub!('Гы', 'Hy')
	line.gsub!('гы', 'hy')
	line.gsub!('Гэ', 'He')
	line.gsub!('гэ', 'he')
	line.gsub!('Гю', 'Hiu')
	line.gsub!('гю', 'hiu')
	line.gsub!('Гя', 'Hia')
	line.gsub!('гя', 'hia')

	line.gsub!('Ґа', 'Ga')
	line.gsub!('ґа', 'ga')
	line.gsub!('Ґе', 'Gie')
	line.gsub!('ґе', 'gie')
	line.gsub!('Ґё', 'Gio')
	line.gsub!('ґё', 'gio')
	line.gsub!('Ґі', 'Gi')
	line.gsub!('ґі', 'gi')
	line.gsub!('Ґо', 'Go')
	line.gsub!('ґо', 'go')
	line.gsub!('Ґу', 'Gu')
	line.gsub!('ґу', 'gu')
	line.gsub!('Ґы', 'Gy')
	line.gsub!('ґы', 'gy')
	line.gsub!('Ґэ', 'Ge')
	line.gsub!('ґэ', 'ge')
	line.gsub!('Ґю', 'Giu')
	line.gsub!('ґю', 'giu')
	line.gsub!('Ґя', 'Gia')
	line.gsub!('ґя', 'gia')

	line.gsub!('Да', 'Da')
	line.gsub!('да', 'da')
	line.gsub!('До', 'Do')
	line.gsub!('до', 'do')
	line.gsub!('Ду', 'Du')
	line.gsub!('ду', 'du')
	line.gsub!('Ды', 'Dy')
	line.gsub!('ды', 'dy')
	line.gsub!('Дэ', 'De')
	line.gsub!('дэ', 'de')

	line.gsub!('Дзе', 'Dzie')
	line.gsub!('дзе', 'dzie')
	line.gsub!('Дзё', 'Dzio')
	line.gsub!('дзё', 'dzio')
	line.gsub!('Дзі', 'Dzi')
	line.gsub!('дзі', 'dzi')
	line.gsub!('Дзю', 'Dziu')
	line.gsub!('дзю', 'dziu')
	line.gsub!('Дзя', 'Dzia')
	line.gsub!('дзя', 'dzia')

	line.gsub!('Джа', 'Dža')
	line.gsub!('джа', 'dža')
	line.gsub!('Джо', 'Džo')
	line.gsub!('джо', 'džo')
	line.gsub!('Джу', 'Džu')
	line.gsub!('джу', 'džu')
	line.gsub!('Джы', 'Džy')
	line.gsub!('джы', 'džy')
	line.gsub!('Джэ', 'Dže')
	line.gsub!('джэ', 'dže')

	line.gsub!('Жа', 'Ža')
	line.gsub!('жа', 'ža')
	line.gsub!('Жо', 'Žo')
	line.gsub!('жо', 'žo')
	line.gsub!('Жу', 'Žu')
	line.gsub!('жу', 'žu')
	line.gsub!('Жы', 'Žy')
	line.gsub!('жы', 'žy')
	line.gsub!('Жэ', 'Že')
	line.gsub!('жэ', 'že')

	line.gsub!('За', 'Za')
	line.gsub!('за', 'za')
	line.gsub!('Зе', 'Zie')
	line.gsub!('зе', 'zie')
	line.gsub!('Зё', 'Zio')
	line.gsub!('зё', 'zio')
	line.gsub!('Зі', 'Zi')
	line.gsub!('зі', 'zi')
	line.gsub!('Зо', 'Zo')
	line.gsub!('зо', 'zo')
	line.gsub!('Зу', 'Zu')
	line.gsub!('зу', 'zu')
	line.gsub!('Зы', 'Zy')
	line.gsub!('зы', 'zy')
	line.gsub!('Зэ', 'Ze')
	line.gsub!('зэ', 'ze')
	line.gsub!('Зю', 'Ziu')
	line.gsub!('зю', 'ziu')
	line.gsub!('Зя', 'Zia')
	line.gsub!('зя', 'zia')

	line.gsub!('Ка', 'Ka')
	line.gsub!('ка', 'ka')
	line.gsub!('Ке', 'Kie')
	line.gsub!('ке', 'kie')
	line.gsub!('Кё', 'Kio')
	line.gsub!('кё', 'kio')
	line.gsub!('Кі', 'Ki')
	line.gsub!('кі', 'ki')
	line.gsub!('Ко', 'Ko')
	line.gsub!('ко', 'ko')
	line.gsub!('Ку', 'Ku')
	line.gsub!('ку', 'ku')
	line.gsub!('Кы', 'Ky')
	line.gsub!('кы', 'ky')
	line.gsub!('Кэ', 'Ke')
	line.gsub!('кэ', 'ke')
	line.gsub!('Кю', 'Kiu')
	line.gsub!('кю', 'kiu')
	line.gsub!('Кя', 'Kia')
	line.gsub!('кя', 'kia')

	line.gsub!('Ла', 'Ła')
	line.gsub!('ла', 'ła')
	line.gsub!('Ле', 'Le')
	line.gsub!('ле', 'le')
	line.gsub!('Лё', 'Lo')
	line.gsub!('лё', 'lo')
	line.gsub!('Лі', 'Li')
	line.gsub!('лі', 'li')
	line.gsub!('Ло', 'Ło')
	line.gsub!('ло', 'ło')
	line.gsub!('Лу', 'Łu')
	line.gsub!('лу', 'łu')
	line.gsub!('Лы', 'Ły')
	line.gsub!('лы', 'ły')
	line.gsub!('Лэ', 'Łe')
	line.gsub!('лэ', 'łe')
	line.gsub!('Лю', 'Lu')
	line.gsub!('лю', 'lu')
	line.gsub!('Ля', 'La')
	line.gsub!('ля', 'la')
	
	line.gsub!('Ма', 'Ma')
	line.gsub!('ма', 'ma')
	line.gsub!('Ме', 'Mie')
	line.gsub!('ме', 'mie')
	line.gsub!('Мё', 'Mio')
	line.gsub!('мё', 'mio')
	line.gsub!('Мі', 'Mi')
	line.gsub!('мі', 'mi')
	line.gsub!('Мо', 'Mo')
	line.gsub!('мо', 'mo')
	line.gsub!('Му', 'Mu')
	line.gsub!('му', 'mu')
	line.gsub!('Мы', 'My')
	line.gsub!('мы', 'my')
	line.gsub!('Мэ', 'Me')
	line.gsub!('мэ', 'me')
	line.gsub!('Мю', 'Miu')
	line.gsub!('мю', 'miu')
	line.gsub!('Мя', 'Mia')
	line.gsub!('мя', 'mia')

	line.gsub!('На', 'Na')
	line.gsub!('на', 'na')
	line.gsub!('Не', 'Nie')
	line.gsub!('не', 'nie')
	line.gsub!('Нё', 'Nio')
	line.gsub!('нё', 'nio')
	line.gsub!('Ні', 'Ni')
	line.gsub!('ні', 'ni')
	line.gsub!('Но', 'No')
	line.gsub!('но', 'no')
	line.gsub!('Ну', 'Nu')
	line.gsub!('ну', 'nu')
	line.gsub!('Ны', 'Ny')
	line.gsub!('ны', 'ny')
	line.gsub!('Нэ', 'Ne')
	line.gsub!('нэ', 'ne')
	line.gsub!('Ню', 'Niu')
	line.gsub!('ню', 'niu')
	line.gsub!('Ня', 'Nia')
	line.gsub!('ня', 'nia')

	line.gsub!('Па', 'Pa')
	line.gsub!('па', 'pa')
	line.gsub!('Пе', 'Pie')
	line.gsub!('пе', 'pie')
	line.gsub!('Пё', 'Pio')
	line.gsub!('пё', 'pio')
	line.gsub!('Пі', 'Pi')
	line.gsub!('пі', 'pi')
	line.gsub!('По', 'Po')
	line.gsub!('по', 'po')
	line.gsub!('Пу', 'Pu')
	line.gsub!('пу', 'pu')
	line.gsub!('Пы', 'Py')
	line.gsub!('пы', 'py')
	line.gsub!('Пэ', 'Pe')
	line.gsub!('пэ', 'pe')
	line.gsub!('Пю', 'Piu')
	line.gsub!('пю', 'piu')
	line.gsub!('Пя', 'Pia')
	line.gsub!('пя', 'pia')

	line.gsub!('Ра', 'Ra')
	line.gsub!('ра', 'ra')
	line.gsub!('Ро', 'Ro')
	line.gsub!('ро', 'ro')
	line.gsub!('Ру', 'Ru')
	line.gsub!('ру', 'ru')
	line.gsub!('Ры', 'Ry')
	line.gsub!('ры', 'ry')
	line.gsub!('Рэ', 'Re')
	line.gsub!('рэ', 're')

	line.gsub!('Са', 'Sa')
	line.gsub!('са', 'sa')
	line.gsub!('Се', 'Sie')
	line.gsub!('се', 'sie')
	line.gsub!('Сё', 'Sio')
	line.gsub!('сё', 'sio')
	line.gsub!('Сі', 'Si')
	line.gsub!('сі', 'si')
	line.gsub!('Со', 'So')
	line.gsub!('со', 'so')
	line.gsub!('Су', 'Su')
	line.gsub!('су', 'su')
	line.gsub!('Сы', 'Sy')
	line.gsub!('сы', 'sy')
	line.gsub!('Сэ', 'Se')
	line.gsub!('сэ', 'se')
	line.gsub!('Сю', 'Siu')
	line.gsub!('сю', 'siu')
	line.gsub!('Ся', 'Sia')
	line.gsub!('ся', 'sia')

	line.gsub!('Та', 'Ta')
	line.gsub!('та', 'ta')
	line.gsub!('То', 'To')
	line.gsub!('то', 'to')
	line.gsub!('Ту', 'Tu')
	line.gsub!('ту', 'tu')
	line.gsub!('Ты', 'Ty')
	line.gsub!('ты', 'ty')
	line.gsub!('Тэ', 'Te')
	line.gsub!('тэ', 'te')

	line.gsub!('Фа', 'Fa')
	line.gsub!('фа', 'fa')
	line.gsub!('Фе', 'Fie')
	line.gsub!('фе', 'fie')
	line.gsub!('Фё', 'Fio')
	line.gsub!('фё', 'fio')
	line.gsub!('Фі', 'Fi')
	line.gsub!('фі', 'fi')
	line.gsub!('Фо', 'Fo')
	line.gsub!('фо', 'fo')
	line.gsub!('Фу', 'Fu')
	line.gsub!('фу', 'fu')
	line.gsub!('Фы', 'Fy')
	line.gsub!('фы', 'fy')
	line.gsub!('Фэ', 'Fe')
	line.gsub!('фэ', 'fe')
	line.gsub!('Фю', 'Fiu')
	line.gsub!('фю', 'fiu')
	line.gsub!('Фя', 'Fia')
	line.gsub!('фя', 'fia')

	line.gsub!('Ха', 'Cha')
	line.gsub!('ха', 'cha')
	line.gsub!('Хе', 'Chie')
	line.gsub!('хе', 'chie')
	line.gsub!('Хё', 'Chio')
	line.gsub!('хё', 'chio')
	line.gsub!('Хі', 'Chi')
	line.gsub!('хі', 'chi')
	line.gsub!('Хо', 'Cho')
	line.gsub!('хо', 'cho')
	line.gsub!('Ху', 'Chu')
	line.gsub!('ху', 'chu')
	line.gsub!('Хы', 'Chy')
	line.gsub!('хы', 'chy')
	line.gsub!('Хэ', 'Che')
	line.gsub!('хэ', 'che')
	line.gsub!('Хю', 'Chiu')
	line.gsub!('хю', 'chiu')
	line.gsub!('Хя', 'Chia')
	line.gsub!('хя', 'chia')
	
	line.gsub!('Ца', 'Ca')
	line.gsub!('ца', 'ca')
	line.gsub!('Це', 'Cie')
	line.gsub!('це', 'cie')
	line.gsub!('Цё', 'Cio')
	line.gsub!('цё', 'cio')
	line.gsub!('Ці', 'Ci')
	line.gsub!('ці', 'ci')
	line.gsub!('Цо', 'Co')
	line.gsub!('цо', 'co')
	line.gsub!('Цу', 'Cu')
	line.gsub!('цу', 'cu')
	line.gsub!('Цы', 'Cy')
	line.gsub!('цы', 'cy')
	line.gsub!('Цэ', 'Ce')
	line.gsub!('цэ', 'ce')
	line.gsub!('Цю', 'Ciu')
	line.gsub!('цю', 'ciu')
	line.gsub!('Ця', 'Cia')
	line.gsub!('ця', 'cia')

	line.gsub!('Ча', 'Ča')
	line.gsub!('ча', 'ča')
	line.gsub!('Чо', 'Čo')
	line.gsub!('чо', 'čo')
	line.gsub!('Чу', 'Ču')
	line.gsub!('чу', 'ču')
	line.gsub!('Чы', 'Čy')
	line.gsub!('чы', 'čy')
	line.gsub!('Чэ', 'Če')
	line.gsub!('чэ', 'če')

	line.gsub!('Ша', 'Ša')
	line.gsub!('ша', 'ša')
	line.gsub!('Шо', 'Šo')
	line.gsub!('шо', 'šo')
	line.gsub!('Шу', 'Šu')
	line.gsub!('шу', 'šu')
	line.gsub!('Шы', 'Šy')
	line.gsub!('шы', 'šy')
	line.gsub!('Шэ', 'Še')
	line.gsub!('шэ', 'še')

	line.gsub!('\'е', 'je')
	line.gsub!('\'ё', 'jo')
	line.gsub!('\'і', 'ji')
	line.gsub!('\'ю', 'ju')
	line.gsub!('\'я', 'ja')
	line.gsub!('Дзь', 'Dź')
	line.gsub!('дзь', 'dź')
	line.gsub!('Зь', 'Ź')
	line.gsub!('зь', 'ź')
	line.gsub!('Ль', 'L')
	line.gsub!('ль', 'l')
	line.gsub!('Нь', 'Ń')
	line.gsub!('нь', 'ń')
	line.gsub!('Сь', 'Ś')
	line.gsub!('сь', 'ś')
	line.gsub!('Ць', 'Ć')
	line.gsub!('ць', 'ć')

	line.gsub!('Б', 'B')
	line.gsub!('б', 'b')
	line.gsub!('В', 'V')
	line.gsub!('в', 'v')
	line.gsub!('Г', 'H')
	line.gsub!('г', 'h')
	line.gsub!('Ґ', 'G')
	line.gsub!('ґ', 'g')
	line.gsub!('Дз', 'Dz')
	line.gsub!('дз', 'dz')
	line.gsub!('Дж', 'Dž')
	line.gsub!('дж', 'dž')
	line.gsub!('Д', 'D')
	line.gsub!('д', 'd')
	line.gsub!('Ж', 'Ž')
	line.gsub!('ж', 'ž')
	line.gsub!('З', 'Z')
	line.gsub!('з', 'z')
	line.gsub!('К', 'K')
	line.gsub!('к', 'k')
	line.gsub!('Л', 'Ł')
	line.gsub!('л', 'ł')
	line.gsub!('М', 'M')
	line.gsub!('м', 'm')
	line.gsub!('Н', 'N')
	line.gsub!('н', 'n')
	line.gsub!('П', 'P')
	line.gsub!('п', 'p')
	line.gsub!('Р', 'R')
	line.gsub!('р', 'r')
	line.gsub!('С', 'S')
	line.gsub!('с', 's')
	line.gsub!('Т', 'T')
	line.gsub!('т', 't')
	line.gsub!('Ф', 'F')
	line.gsub!('ф', 'f')
	line.gsub!('Х', 'Ch')
	line.gsub!('х', 'ch')
	line.gsub!('Ц', 'C')
	line.gsub!('ц', 'c')
	line.gsub!('Ч', 'Č')
	line.gsub!('ч', 'č')
	line.gsub!('Ш', 'Š')
	line.gsub!('ш', 'š')

	line.gsub!('Й', 'J')
	line.gsub!('й', 'j')
	line.gsub!('А', 'A')
	line.gsub!('а', 'a')
	line.gsub!('Е', 'Je')
	line.gsub!('е', 'je')
	line.gsub!('Ё', 'Jo')
	line.gsub!('ё', 'jo')
	line.gsub!('І', 'I')
	line.gsub!('і', 'i')
	line.gsub!('О', 'O')
	line.gsub!('о', 'o')
	line.gsub!('У', 'U')
	line.gsub!('у', 'u')
	line.gsub!('Ў', 'Ŭ')
	line.gsub!('ў', 'ŭ')
	line.gsub!('Ы', 'Y')
	line.gsub!('ы', 'y')
	line.gsub!('Э', 'E')
	line.gsub!('э', 'e')
	line.gsub!('Ю', 'Ju')
	line.gsub!('ю', 'ju')
	line.gsub!('Я', 'Ja')
	line.gsub!('я', 'ja')
end

while line = gets
	cyr2lat(line)
	puts line
end
